			#include<p16f628.inc>			;

;-----------------------------------------------------------------------------------------------------
			__CONFIG	3F14				;
			errorlevel-302					;
;-----------------------------------------------------------------------------------------------------
			cblock		H'30'				;   
			cnt_bin							;
			cnt0							;
			cnt1							;
			cnt2							;
			cnt3							;
			cnt4							;
			cnt5							;
			cnt_1							; 
			cnt_10							; 
			cnt_100						; 
			r_tmp							;
			endc							;   
			org 0							;
			goto 		S__T				;
			org 4							;
			retfie							;		
;----------------------------------------------------------	
S__T		clrf			PORTB				;  
			bsf			STATUS,RP0		; 1
			clrf			TRISB				;   
			movlw		B'00111100'		;RA0,1,6,7  
			movwf		TRISA				;  	
			clrf			INTCON			; 
			movlw		B'00001111'		;
			movwf		OPTION_REG		; WDT
			bcf			STATUS,RP0		; 0
			movlw		B'00000111'		;
			movwf		CMCON			;.
			clrf			CCP1CON			;
;-----------------------------------------------------------
START		clrf			cnt_bin				;
;----------------------   -----------------	
SSTA		movfw		cnt_bin				;
			movwf		PORTB				;
			bsf			PORTA,6			;
			nop							;
			bcf			PORTA,6			;
			call			PREOBR			;
			call			IND					;
			call			IND					;
			call			IND					;
			call			IND					;
;-----------------------------------------------------------			
SSTT		movfw		cnt_bin				;
			movwf		PORTB				;
			bsf			PORTA,6			;
			nop							;
			bcf			PORTA,6			;
			call			PREOBR			;
			call			IND					;
;----------------------------------------------------------
			btfss		PORTA,5			;
			goto		START				;
			btfss		PORTA,2			;
			goto		MNS				;
			btfss		PORTA,3			;
			goto		PLS				;
			btfss		PORTA,4			;
			goto		RBU				;
			goto		SSTT				;
;------------------------------------------------------------
MNS		call			MINUS				;
			goto		SSTT				;
;-------------------------------------------------------------
PLS		call			PLUS				;
			goto		SSTT				;
;--------------  -----
PLUS		btfsc		PORTA,	4			;  SB3
			goto		INKR				;  ,    INKR
			movlw		D'10'				; ,   10
			addwf		cnt_bin				;  cnt_bin	
			btfsc		STATUS,C			; 
			goto		RRR				; ,  
			goto		O_P				;  ,  	
INKR		movlw		D'1'					;  1
			addwf		cnt_bin				;  
			btfsc		STATUS,C			;  
			goto		SSS				; ,  
			goto		O_P				;  ,  
SSS		subwf		cnt_bin				;   
			goto		O_P				;
RRR		subwf		cnt_bin				;   10
O_P		nop							;
			return							;  
;------------  -----
MINUS		btfsc		PORTA,4			;
			goto		DEKR				;
			movlw		D'10'				;
			subwf		cnt_bin				;
			btfss		STATUS,C			;
			goto		UUU				;
			goto		O_M				;
DEKR		movlw		D'1'					;
			subwf		cnt_bin				;
			btfss		STATUS,C			;
			goto		ZZZ				;
			goto		O_M				;
UUU		addwf		cnt_bin				;
			goto		O_M				;
ZZZ		addwf		cnt_bin				;
O_M		nop							;
			return							;
;-----  ------
RBU		movfw		cnt_bin				;
			movwf		cnt4				;
			bcf			cnt_1,7				;
			call			IND					;
			call			IND					;
RAA		movlw		D'40'				;   .
			movwf		cnt5				; 
RA			movlw		D'10'				;    .
			movwf		cnt1				; 
			call			PREOBR			;
			bcf			cnt_1,7				;  
			call			INDA				;
			btfss		PORTA,2			; SB1
			goto		M_S				;
			btfss		PORTA,3			; SB2
			goto		P_S				;
			btfss		PORTA,4			; SB3
			goto		EX_U				;
			btfss		PORTA,5			; SB4
			goto		EX_S				;
			decfsz		cnt5				;  
			goto		RA					;
			goto		EX_S				;
M_S		call			MINUS				;
			goto		RAA				;
P_S		call			PLUS				;
			goto		RAA				;
EX_S		movfw		cnt4				;
			movwf		cnt_bin				;
			goto		SSTA				;
EX_U		movlw		D'4'					;
			movwf		r_tmp				;
ZZ			call			IND					;
			btfss		PORTA,2			; SB1
			goto		RAA				;
			btfss		PORTA,3			; SB2
			goto		RAA				;
			btfsc		PORTA,4			; SB3
			goto		RAA				;
			btfss		PORTA,5			; SB4
			goto		EX_S				;
			decfsz		r_tmp				;
			goto		ZZ					;
			goto		SSTA				;		
;----------     ----------
DC7		addwf		PCL,F				;
			retlw		D'192'				;0___ 0
			retlw		D'249'				;1___ 1
			retlw		D'164'				;2___ 2
			retlw		D'176'				;3___ 3
			retlw		D'153'				;4___ 4
			retlw		D'146'				;5___ 5
			retlw		D'130'				;6___ 6
			retlw		D'248'				;7___ 7
			retlw		D'128'				;8___ 8
			retlw		D'144'				;9___ 9
			retlw		D'255'				;10___
;----------- -----------
IND			movlw		D'20'				;   
			movwf		cnt1				; .
INDA		movfw		cnt_1				;
			movwf		PORTB				;
			bsf			PORTA,7			;
			call			delay				;
			bcf			PORTA,7			;
			movfw		cnt_10				;
			movwf		PORTB				;
			bsf			PORTA,0			;
			call			delay				;
			bcf			PORTA,0			;
			movfw		cnt_100			;
			movwf		PORTB				;
			bsf			PORTA,1			;
			call			delay				;
			bcf			PORTA,1			;
			decfsz		cnt1				;
			goto		INDA				;
			clrwdt							;
			return							;
;---------    ------
;------------  - ---------------
PREOBR;----------------------------------------------;
			clrf			cnt_100			;
			clrf			cnt_10				;
			clrf			cnt_1				;
			movfw		cnt_bin				;
			movwf		cnt3				;
;----------------------------------------------------------
RRU		movlw		D'100'				;
			subwf		cnt3				;
			btfss		STATUS,C			;
			goto		WWW				;
			incf		cnt_100			;
			goto		RRU				;
WWW		movlw		D'100'				;
			addwf		cnt3				;
			nop							;
;----------------------------------------------------------
			movlw		D'10'				;
DECR		subwf		cnt3				;
			btfss		STATUS,C			;
			goto		VVV				;
			incf		cnt_10				;
			goto		DECR				;
VVV		addwf		cnt3				;
			movfw		cnt3				;
			movwf		cnt_1				;
			nop							;
;--------   . ------------
			movlw		D'1'					;
			subwf		cnt_100,0			;
			btfss		STATUS,C			;
			goto		NUL				;
			movfw		cnt_100			;
			call			DC7				;
			movwf		cnt_100			;		
EDC		movfw		cnt_10				;
			call			DC7				;
			movwf		cnt_10				;
			nop							;
EDZ		movfw		cnt_1				;
			call			DC7				;
			movwf		cnt_1				;
			return							;
;-----------------------------------------------------------
NUL		movlw		D'10'				;
			call			DC7				;
			movwf		cnt_100			;
			movlw		D'1'					;
			subwf		cnt_10,0			;
			btfsc		STATUS,C			;
			goto		EDC				;
			movlw		D'10'				;
			call			DC7				;
			movwf		cnt_10				;
			goto		EDZ				;
;------------  -------------
delay		movlw		D'10'				;
			movwf		cnt2				;
ckl			movlw		D'200'				;
			movwf		cnt0				;			
ckl1		decfsz		cnt0				;
			goto		ckl1				;
			decfsz		cnt2				;
			goto		ckl					;
			clrwdt							;
			return							;
			end;